/* Written by Michael Haardt, 1994. */
/* Warning: This function could probably be improved numerically. */

static double e100[10]={ 1, 1e100, 1e200, 1e300, 0, 0, 0, 0, 0, 0 };
static double e10[10]={ 1, 1e10, 1e20, 1e30, 1e40, 1e50, 1e60, 1e70, 1e80, 1e90 };
static double e1[10]={ 1, 1e1, 1e2, 1e3, 1e4, 1e5, 1e6, 1e7, 1e8, 1e9 };
static double e_100[10]={ 1, 1e-100, 1e-200, 1e-300, 0, 0, 0, 0, 0, 0 };
static double e_10[10]={ 1, 1e-10, 1e-20, 1e-30, 1e-40, 1e-50, 1e-60, 1e-70, 1e-80, 1e-90 };
static double e_1[10]={ 1, 1e-1, 1e-2, 1e-3, 1e-4, 1e-5, 1e-6, 1e-7, 1e-8, 1e-9 };

/*{{{  strtod*/
double strtod(const char *p, char **end)
{
  /*{{{  variables*/
  double x=0.0;
  int e;
  /*}}}  */

  /*{{{  mantissa*/
  {
    /*{{{  variables*/
    int sign;
    /*}}}  */
  
    /*{{{  sign*/
    switch (*p)
    {
      case '-': ++p; sign=-1; break;
      case '+': ++p;
      default: sign=1;
    }
    /*}}}  */
    /*{{{  absolute value*/
    while (*p>='0' && *p<='9')
    {
      x=10*x+(*p-'0');
      ++p;
    }
    if (*p=='.')
    {
      ++p;
      e=0;
      while (*p>='0' && *p<='9')
      {
        ++e;
        x+=(((*p-'0')*e_1[e%10])*e_10[(e/10)%10])*e_100[e/100];
        ++p;
      }
    }
    /*}}}  */
    x*=sign;
  }
  /*}}}  */
  /*{{{  exponent*/
  if (*p=='e' || *p=='E')
  {
    /*{{{  variables*/
    int sign;
    /*}}}  */
  
    ++p;
    e=0;
    /*{{{  sign*/
    switch (*p)
    {
      case '-': sign=-1; ++p; break;
      case '+': ++p;
    }
    /*}}}  */
    /*{{{  absolute value*/
    while (*p>='0' && *p<='9')
    {
      e=10*e+(*p-'0');
      ++p;
    }
    /*}}}  */
    if (sign==-1) x*=e_100[e/100]*(e_10[(e/10)%10]*e_1[e%10]);
    else x*=e100[e/100]*(e10[(e/10)%10]*e1[e%10]);
  }
  /*}}}  */
  if (end!=(char**)0) *end=(char*)p;
  return x;
}
/*}}}  */
